;###############################################################################
;
;	PIC FRISK VIBRATOR
;
;		Assemble by pa-3.0.5s(b5e0048474cce2a1ba49a54faf9b1e86 */usr/local/bin/pa.exe)
;
;-------------------------------------------------------------------------------
;
;	إå
;
		include		my12f675.h
		.16f84				; PIC16F84()

;-------------------------------------------------------------------------------
;
;	ϥݡ
;
trisIo		equ	11111100b		; (0:, 1:())
vibra		equ	0			; ư⡼
vibraXor	equ	00000001b
led		equ	1			; ɽLED
buttonA		equ	2			; Aܥ
buttonB		equ	3			; Bܥ
buttonAB	equ	00001100b		; ABܥ

vibraTimes	equ	12

;-------------------------------------------------------------------------------
;
;	ꥻ
;
		org	20h			; ޥå

aTemp		ds	1			; A쥸
sTemp		ds	1			; STATUS쥸

pSec		ds	1			; óȯ

sec		ds	1			; 
min		ds	1			;         ʬ
hour		ds	1			;         
nSec		ds	1			; 60 - 
nMin		ds	1			; 60 - ʬ
nHour		ds	1			; 6  - 

vibraOn		ds	1
timerOn		ds	1
timerL		ds	1			; timerL = 2.5min = 150sec
timerH		ds	1			; timerH = 20 x 12 x 2.5min = 600min = 10hour

flashMin1	ds	1
flashHour	ds	1
flashMin2	ds	1

crntGpio	ds	1			; GPIOΥХåե
lastGpio	ds	1			; GPIO
diffGpio	ds	1			; GPIO

alterA		ds	1			; Aβ(Υ)줿
alterB		ds	1			; Bβ(Υ)줿
nonPush		ds	1			; ܥ󤬲ʤä

waitCntS	ds	1			; Ԥѥ
waitCntL	ds	1

		eeorg	0			; EEDATA
		eedata	4			; Start min (0 - 59)
		eedata	4			; Start hour(0 - 5)

;-------------------------------------------------------------------------------
;
;	ץॻ
;
		org	00h			; ꥻåȥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	߽
;
		org	04h			; ߥ٥
isrStart
		LD	(aTemp),A		; 쥸
		SWAP	(STATUS)>A
		RES	RP0, (STATUS)		; Х0
		LD	(sTemp),A
isrTimer
		BIT	T0IF, (INTCON)		; ޳ȯ=1
		JP	Z, isrGpio
		RES	T0IF, (INTCON)		; ȯե饰ߤ
		INC	(pSec)			; вÿ + 1
isrGpio
;		BIT	GPIF, (INTCON)		; GPIOѲȯ=1
;		JP	Z, isrEnd
;		RES	GPIF, (INTCON)		; ȯե饰ߤ
;		SET	BUTTON, (EVENT)		; ٥ȯե饰å
isrEnd
		SWAP	(sTemp)>A		; 쥸
		LD	(STATUS),A
		SWAP	(aTemp)
		SWAP	(aTemp)>A
		RETI

;-------------------------------------------------------------------------------
;
;	å׽
;
start
		RES	RP0, (STATUS)		; Х0

		CLR	(GPIO)			; ݡȤ
		LD	A, 00000111b
		LD	(CMCON), A		; ѥ졼OFF

		SET	RP0, (STATUS)		; Х1

		CLR	(ANSEL)			; A/DѴOFF
		LD	A, trisIo		; :11111111b
		LD	(TRISIO), A		; ݡ
;		LD	A, 00110111b		; :--11-111b
;		LD	(WPU), A		; ץ륢åץå
;		LD	A, 00000000b		; :--000000b
;		LD	(IOC), A		; ݡѲȯݡ

timerSet	CLR	(WDT)			; åɥåޡץꥹ饯ꥢ

		SET	RP0, (STATUS)		; Х1

		LD	A, 00000100b		; :11111111b
		LD	(OPTION), A		; 7:GPIOץ륢å(0:Ѥ)
						; 6:GP2ߥݡѲ(0:Ω)
						; 5:TMR0åӥå(0:)
						; 4:
						; 3:ץꥹƥӥå(0:TMR0)
						; 2~0ץꥹ졼ӥå(111:1/256)

		RES	RP0, (STATUS)		; Х0

		CLR	(TMR0)			; ޥꥢ
intStart
		LD	A, 10100000b		; :00000000b
		LD	(INTCON), A		; 7:Хߥ֥͡
						; 5:TMR0Сեߥ֥͡
						; 4:GP2ݡѲߥ֥͡
						; 3:ݡѲߥ֥͡

;--------------------------------------------------------------------------------
;
;	ɤ߹
;
getInitTime
		SET	RP0, (STATUS)		; Х1

		CLR	(sec)			;  = 0
		LD	A, 60
		LD	(nSec), A

		CLR	(EEADR)
		SET	RD, (EECON1)		; EE Read
		LD	A, (EEDATA)
		LD	(min), A		; ʬ = 
		SUB	60, A>A
		LD	(nMin), A

		INC	(EEADR)
		SET	RD, (EECON1)		; EE Read
		LD	A, (EEDATA)
		LD	(hour), A		;  = 
		SUB	6, A>A
		LD	(nHour), A

		RES	RP0, (STATUS)		; Х0

;--------------------------------------------------------------------------------
;
;	ᥤ
;
		CLR	(pSec)
		CLR	(alterA)
		CLR	(alterB)
		CLR	(nonPush)
		CLR	(vibraOn)
main
		LD	A, 18			; 㥿ɻѥץ󥰴ֳ
		CALL	waitNx4p8		; 2Ԥ 18 x 4 + 8 = 80 / 8192 sec 

		CALL	timeKeep
main1
		LD	A, (GPIO)
		LD	(crntGpio), A		; ߤGPIO CURrent_GPIO ˥ԡ
		CALL	checkButton
		LD	A, (crntGpio)
		LD	(lastGpio), A		; GPIOȤ LaST_GPIO ݻ
main2
		JP	main

;--------------------------------------------------------------------------------
;
;	׻ & ͼԤ
;
timeKeep
		LD	A, (pSec)
		RET	Z			; 0ʤóߤȯƤʤ
		DEC	(pSec)

		LD	A, (vibraOn)
		JP	Z, timeKeep0		; 0ʤ鿶ư
		DEC	(vibraOn)

		LD	A, vibraXor
		XOR	(GPIO), A
timeKeep0
		INC	(sec)			; +1sec
		DJNZ	(nSec), timeKeep1
		CLR	(sec)
		LD	A, 60
		LD	(nSec), A

		INC	(min)			; +1min
		DJNZ	(nMin), timeKeep1
		CLR	(min)
		LD	A, 60
		LD	(nMin), A

		INC	(hour)			; +1hour
		DJNZ	(nHour), timeKeep1
		CLR	(hour)
		LD	A, 6
		LD	(nHour), A
timeKeep1
		LD	A, (timerOn)		; ޷¬⡼ɤ
		JP	Z, timeKeep2

		DJNZ	(timerL), timeKeep2
		LD	A, 150
		LD	(timerL), A

		DJNZ	(timerH), timeKeep2
		CLR	(timerOn)		; ޷¬⡼ɥ
		LD	A, vibraTimes
		LD	(vibraOn), A		; ư
timeKeep2
		LD	A, (nonPush)
		RET	Z			; 0ʤ饿ͼǤʤ
		DEC	(nonPush)

		LD	A, (nonPush)
		SUB	1, A>A			; 1ʤ饿ͤ
		CALL	Z, showTimer
		RET

;--------------------------------------------------------------------------------
;
;	ͼ & ɽ
;
showTimer
		CLR	(timerL)		; timerL = 2.5min = 150sec
		CLR	(timerH)		; timerH = 20 x 12 x 2.5min = 600min = 10hour
		CLR	(timerOn)

		RES	C, (STATUS)		; ꡼ե饰ꥻå
		RR	(alterA)		; Aܥβ(Υ)줿 / 2
		LD	A, (alterA)
		JP	Z, showTimer2		; AܥϲƤʤ
showTimer1
		SET	led, (GPIO)		; 
		LD	A, 1
		CALL	waitNx0125		; wait 0.125 sec
		LD	A, 2
		ADD	(timerL), A		; + 5min : 2.5min x 2
		RES	led, (GPIO)		; 
		LD	A, 1
		CALL	waitNx0125		; wait 0.125 sec
		DJNZ	(alterA), showTimer1
showTimer2
		RES	C, (STATUS)		; ꡼ե饰ꥻå
		RR	(alterB)		; Bܥβ(Υ)줿 / 2
		LD	A, (alterB)
		JP	Z, showTimer4		; BܥϲƤʤ

		LD	A, 5
		CALL	waitNx0125		; wait 0.625 sec
showTimer3
		SET	led, (GPIO)		; 
		LD	A, 2
		CALL	waitNx0125		; wait 0.250 sec
		LD	A, 12
		ADD	(timerL), A		; + 30min : 2.5min x 12
		RES	led, (GPIO)		; 
		LD	A, 2
		CALL	waitNx0125		; wait 0.250 sec
		DJNZ	(alterB), showTimer3
showTimer4
		INC	(timerL)
		INC	(timerH)
		INC	(timerOn)		; ޷¬⡼ɤ

		RET

;--------------------------------------------------------------------------------
;
;	ܥϥå
;
checkButton
		LD	A, (crntGpio)
		AND	A, buttonAB		; פʥӥåȤȤ
		JP	Z, checkButton3		; ӥå0ʤABƱ줿

		LD	A, (lastGpio)
		LD	(diffGpio), A		; GPIOפФ
		LD	A, (crntGpio)
		XOR	(diffGpio), A		; ߤGPIOȤκʬȤ

		BIT	buttonA, (diffGpio)
		JP	Z, checkButton1
		INC	(alterA)		; Aܥβ(Υ)줿 + 1
		LD	A, 4			; 3ø˥ͤ
		LD	(nonPush), A
checkButton1
		BIT	buttonB, (diffGpio)
		JP	Z, checkButton2
		INC	(alterB)		; Bܥβ(Υ)줿 + 1
		LD	A, 4			; 3ø˥ͤ
		LD	(nonPush), A
checkButton2
		RET

checkButton3					; ABƱ줿
		CLR	(timerOn)		; ¬Υޤϲ
		CALL	showNowTime		; ɽ
		CLR	(alterA)		; AܥͤΤƤ
		CLR	(alterB)		; BܥͤΤƤ
		CLR	(nonPush)		; ͤμߤ
		LD	A, (GPIO)		; ƱƤϥΡġ
		LD	(crntGpio), A		; ߤGPIO CURrent_GPIO ˥ԡ

		CLR	(vibraOn)		; ư
checkButton9
		RET

################################################################################
#
#	ɽ
#
showNowTime					; ɽ
		RES	led, (GPIO)		; 
		CLR	(flashMin1)
		LD	A, (min)		; get 0-59
showNowTime1
		INC	(flashMin1)		; 1~12
		ADD	A, 0fbh			; 0xfb = -5
		JP	C, showNowTime1		; 0~4=>1, 5~9=>2, 30~34=>7, 55~59=>12
		ADD	A, 6
		LD	(flashMin2), A		; 1~5

		LD	A, (hour)		; get 0-23
showNowTime2
		ADD	A, 0fah			; 0xfa = -6
		JP	C, showNowTime2
		ADD	A, 6			; 0~5
		JP	NZ, showNowTime3
		ADD	A, 6			; 0->6
showNowTime3
		ADD	A, 1
		LD	(flashHour), A		; 2~7

showMin1					; 0-11 times
		RES	led, (GPIO)		; 
		LD	A, 1
		CALL	waitNx0125		; wait 0.125 sec
		DEC	(flashMin1)
		JP	Z, showHourWait
		SET	led, (GPIO)		; 
		LD	A, 1
		CALL	waitNx0125		; wait 0.125 sec
		JP	showMin1
showHourWait
		LD	A, 5
		CALL	waitNx0125		; wait 0.625 sec
showHour					; 1-6 times
		RES	led, (GPIO)		; 
		LD	A, 2
		CALL	waitNx0125		; wait 0.250 sec
		DEC	(flashHour)
		JP	Z, showMinWait
		SET	led, (GPIO)		; 
		LD	A, 2
		CALL	waitNx0125		; wait 0.250 sec
		JP	showHour
showMinWait
		LD	A, 5
		CALL	waitNx0125		; wait 0.625 sec
showMin2					; 0-4 times
		RES	led, (GPIO)		; 
		LD	A, 1
		CALL	waitNx0125		; wait 0.125 sec
		DEC	(flashMin2)
		JP	Z, showNowTime9
		SET	led, (GPIO)		; 
		LD	A, 1
		CALL	waitNx0125		; wait 0.125 sec
		JP	showMin2
showNowTime9
		RET

################################################################################
#
#	Ԥ()
#
#		LD	A, 6			; 6ꤹȡ
#		CALL	waitNx4p8		; 2Ԥ 6 x 4 + 8 = 1/256sec 
#
waitNx4p8
		LD	(waitCntS), A
waitNx4p81	NOP
		DJNZ	(waitCntS), waitNx4p81
		NOP
		NOP
		NOP
		RET

################################################################################
#
#	Ԥ()
#
#		LD	A, 8			; 1äξ硢8ꤹȡ
#		CALL	waitNx0125		; 2Ԥ 8 x 1/8sec - 10clock 񤹤
#
waitNx0125
		LD	(waitCntL), A
		LD	A, 249
		JP	waitNx01252
waitNx01251	NOP
		LD	A, 253			; 253 x 4 + 8 = 1/8sec - 4clock
waitNx01252	CALL	waitNx4p8		;		λԤ
		DJNZ	(waitCntL), waitNx01251
		RET

